//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A928AC60278.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A928AC60278.cm

//## begin module%3A928AC60278.cp preserve=no
//## end module%3A928AC60278.cp

//## Module: ParameterLink%3A928AC60278; Package body
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Parameter/ParameterLink.cxx

//## begin module%3A928AC60278.additionalIncludes preserve=no
//## end module%3A928AC60278.additionalIncludes

//## begin module%3A928AC60278.includes preserve=yes
//## end module%3A928AC60278.includes

// ModelContainer
#include <XSModel/GlobalContainer/ModelContainer.h>
// SwitchParam
#include <XSModel/Parameter/SwitchParam.h>
// ScaleParam
#include <XSModel/Parameter/ScaleParam.h>
// XSutility
#include <XSUtil/Utils/XSutility.h>
// ModParam
#include <XSModel/Parameter/ModParam.h>
// ParameterLink
#include <XSModel/Parameter/ParameterLink.h>


//## begin module%3A928AC60278.declarations preserve=no
//## end module%3A928AC60278.declarations

//## begin module%3A928AC60278.additionalDeclarations preserve=yes
#include <XSUtil/Parse/XSparse.h>
#include <XSstreams.h>
#include <XSContainer.h>
#include <XSModel/Data/SpectralData.h>
#include <XSModel/GlobalContainer/DataContainer.h>
#include <XSModel/GlobalContainer/ResponseContainer.h>
#include <XSModel/Model/Component/ComponentBase.h>
#include <XSModel/Model/Component/CGroupBase.h>
#include <XSModel/Parameter/Parameter.h>
#include <XSModel/Parameter/ResponseParam.h>
#include <XSUtil/Utils/XSstream.h>
#include <cctype>
#include <sstream>
using std::endl;
//## end module%3A928AC60278.additionalDeclarations


// Class ParameterLink::InvalidInput 

ParameterLink::InvalidInput::InvalidInput (const string& msg)
  //## begin ParameterLink::InvalidInput::InvalidInput%39172B593BF0.hasinit preserve=yes
  : YellowAlert("Invalid link expression: ")
  //## end ParameterLink::InvalidInput::InvalidInput%39172B593BF0.hasinit
  //## begin ParameterLink::InvalidInput::InvalidInput%39172B593BF0.initialization preserve=yes
  //## end ParameterLink::InvalidInput::InvalidInput%39172B593BF0.initialization
{
  //## begin ParameterLink::InvalidInput::InvalidInput%39172B593BF0.body preserve=yes
   tcerr << msg << endl;
  //## end ParameterLink::InvalidInput::InvalidInput%39172B593BF0.body
}


// Class ParameterLink::ParseFailure 

ParameterLink::ParseFailure::ParseFailure (const string& msg)
  //## begin ParameterLink::ParseFailure::ParseFailure%3921691E001A.hasinit preserve=yes
  : RedAlert(msg)
  //## end ParameterLink::ParseFailure::ParseFailure%3921691E001A.hasinit
  //## begin ParameterLink::ParseFailure::ParseFailure%3921691E001A.initialization preserve=yes
  //## end ParameterLink::ParseFailure::ParseFailure%3921691E001A.initialization
{
  //## begin ParameterLink::ParseFailure::ParseFailure%3921691E001A.body preserve=yes
  //## end ParameterLink::ParseFailure::ParseFailure%3921691E001A.body
}


// Class ParameterLink::DivideCheck 

ParameterLink::DivideCheck::DivideCheck (const string& msg)
  //## begin ParameterLink::DivideCheck::DivideCheck%3921A58A02FA.hasinit preserve=yes
        : YellowAlert(" Link expression gives divide by zero error: ")
  //## end ParameterLink::DivideCheck::DivideCheck%3921A58A02FA.hasinit
  //## begin ParameterLink::DivideCheck::DivideCheck%3921A58A02FA.initialization preserve=yes
  //## end ParameterLink::DivideCheck::DivideCheck%3921A58A02FA.initialization
{
  //## begin ParameterLink::DivideCheck::DivideCheck%3921A58A02FA.body preserve=yes
   tcerr << msg << endl;
  //## end ParameterLink::DivideCheck::DivideCheck%3921A58A02FA.body
}


// Class ParameterLink::NoValidParametersInExpression 

ParameterLink::NoValidParametersInExpression::NoValidParametersInExpression (const string& msg)
  //## begin ParameterLink::NoValidParametersInExpression::NoValidParametersInExpression%3AB8CDF50226.hasinit preserve=yes
        : YellowAlert("Link expression contains no valid parameters:  = ")
  //## end ParameterLink::NoValidParametersInExpression::NoValidParametersInExpression%3AB8CDF50226.hasinit
  //## begin ParameterLink::NoValidParametersInExpression::NoValidParametersInExpression%3AB8CDF50226.initialization preserve=yes
  //## end ParameterLink::NoValidParametersInExpression::NoValidParametersInExpression%3AB8CDF50226.initialization
{
  //## begin ParameterLink::NoValidParametersInExpression::NoValidParametersInExpression%3AB8CDF50226.body preserve=yes
  tcerr << msg << endl;
  //## end ParameterLink::NoValidParametersInExpression::NoValidParametersInExpression%3AB8CDF50226.body
}


// Class ParameterLink 

//## begin ParameterLink::FLAGVALUE%3A9292960137.attr preserve=no  public: static int {VC} -999
const int ParameterLink::s_FLAGVALUE = -999;
//## end ParameterLink::FLAGVALUE%3A9292960137.attr

ParameterLink::ParameterLink(const ParameterLink &right)
  //## begin ParameterLink::ParameterLink%362F93D90212_copy.hasinit preserve=yes
      : m_boolean(right.m_boolean), 
        m_linkVal(right.m_linkVal), 
        m_parent(right.m_parent),
        m_members(right.m_members),
        m_linkString(right.m_linkString)
  //## end ParameterLink::ParameterLink%362F93D90212_copy.hasinit
  //## begin ParameterLink::ParameterLink%362F93D90212_copy.initialization preserve=yes
  //## end ParameterLink::ParameterLink%362F93D90212_copy.initialization
{
  //## begin ParameterLink::ParameterLink%362F93D90212_copy.body preserve=yes
  //## end ParameterLink::ParameterLink%362F93D90212_copy.body
}

ParameterLink::ParameterLink (const string& linkExpression, const Parameter* p, bool isBoolean)
  //## begin ParameterLink::ParameterLink%3905CA752C60.hasinit preserve=yes
      : m_boolean(isBoolean),
        m_linkVal(0),
        m_parent(p),     
        m_members(),
        m_linkString()
  //## end ParameterLink::ParameterLink%3905CA752C60.hasinit
  //## begin ParameterLink::ParameterLink%3905CA752C60.initialization preserve=yes
  //## end ParameterLink::ParameterLink%3905CA752C60.initialization
{
  //## begin ParameterLink::ParameterLink%3905CA752C60.body preserve=yes
    m_linkString.init(linkExpression);    
    if (isBoolean && m_linkString.tokenList().size() > 1)  
    {
       throw ParameterLink::InvalidInput("Switches may only take links of type par x = par y");
    }
    
    std::vector<bool> isParFound(m_linkString.parIDs().size(), false);
    LinkExpression::ParamInfo::const_iterator itParID = m_linkString.parIDs().begin();    
    LinkExpression::ParamInfo::const_iterator itParIDEnd = m_linkString.parIDs().end(); 
    size_t iCount=0;   
    bool atLeastOneFound = false;
    const ResponseParam* respPar = dynamic_cast<const ResponseParam*>(m_parent);
    while (itParID != itParIDEnd)
    {
        bool thisParFound = respPar ? wordToResponseParam(itParID->first) :
                              wordToParam(itParID->first);
        if (thisParFound)
        {
           isParFound[iCount] = true;
           atLeastOneFound = true;
        }
        ++itParID, ++iCount;
    }
    if (!atLeastOneFound)
       throw NoValidParametersInExpression(linkExpression);
     
    m_linkString.resetParamInfo(isParFound);
    
  //## end ParameterLink::ParameterLink%3905CA752C60.body
}


ParameterLink::~ParameterLink()
{
  //## begin ParameterLink::~ParameterLink%362F93D90212_dest.body preserve=yes
  // manages no heap memory: no owning pointers, just stack allocated
  // LinkExpression instance.
  //## end ParameterLink::~ParameterLink%362F93D90212_dest.body
}


ParameterLink & ParameterLink::operator=(const ParameterLink &right)
{
  //## begin ParameterLink::operator=%362F93D90212_assign.body preserve=yes
  ParameterLink __temp(right);
  swap(__temp);
  return *this;
  //## end ParameterLink::operator=%362F93D90212_assign.body
}



//## Other Operations (implementation)
void ParameterLink::swap (ParameterLink& right)
{
  //## begin ParameterLink::swap%373B0D32E291.body preserve=yes
    XSutility::swap(m_linkString,right.m_linkString);
    XSutility::swap(m_parent,right.m_parent);
    XSutility::swap(m_boolean,right.m_boolean);
    XSutility::swap(m_members,right.m_members);  
  //## end ParameterLink::swap%373B0D32E291.body
}

bool ParameterLink::wordToParam (const string& word)
{
  //## begin ParameterLink::wordToParam%3918569E005B.body preserve=yes
  // "words" that evaluate to parameters are strings of the form:
  // 1) n - integers [no decimal point or exponent] as per XSPEC11
  // 2) modelName:n  - same but with a model name qualifier. Without, it refers to
  //                   the default model.
  
  bool isAdded = false;
  string modelName;
  size_t parNum = XSutility::isInteger(word);

  if (parNum != string::npos)
  {             
     // If it can't find a parameter named with only an integer,
     // we'll let it pass.  The LinkExpression class will treat
     // it as a numerical constant (and issue a warning).
     isAdded = addPointer(parNum);
  }
  else
  {
     // If word is coming from LinkExpression parIDs list, it
     // must either be an int or a string:int.  Still, it can't
     // hurt to double check here.        
     XSparse::stringIntPair(word,modelName,parNum);

     if (parNum == string::npos)
     {
        throw ParameterLink::InvalidInput
                  (" Parameter reference must be of form [ModelName:]n");          
     }
     else
     {
        if (!(isAdded = addPointer(parNum,modelName)))  
        {
           // the only possible response here is to throw an 
           // InvalidInput exception.
           // because a string has been entered that doesn't correspond to a
           // valid model parameter.
           std::ostringstream msg;
           msg << "No matching parameter for parameter reference " << word
              << " in link expression.";
           throw ParameterLink::InvalidInput(msg.str());
        }    
     }
  }
  return isAdded;
  //## end ParameterLink::wordToParam%3918569E005B.body
}

bool ParameterLink::addPointer (int num, const string& modelName)
{
  //## begin ParameterLink::addPointer%391AD167039F.body preserve=yes
  bool added(false);
  const Parameter* ptr = 0;
  
  // First check if link is to a parameter within same model
  // (and NOT a previously existing model with same name in global
  // container that is about to be replaced).
  const ComponentBase* cparent = m_parent->parent();
  const ModelBase* modelParent = 0;
  if(cparent)
  {
      modelParent = cparent->parent()->parent();
      if (modelParent && modelName == modelParent->name())
         ptr = modelParent->getLocalParameter(num);
  }
  
  if (!ptr)       
     ptr = XSContainer::models->lookupParameter(num,modelName);       
         
  if (ptr == parent())
  {
        throw ParameterLink::InvalidInput(" Attempt to link parameter to itself");   
  }
   
  // we apparently have a valid parameter, but not all requested links 
  // make sense. 
  if (ptr != 0)
  {
        // disallow some conditions.
        if (boolean() && !dynamic_cast<const SwitchParam*>(ptr))
        {
            // a boolean may not be linked to anything other than a boolean.
            throw ParameterLink::InvalidInput
                    (" Attempt to create link from switch to real valued parameter");
        }    
        else if (!boolean() && dynamic_cast<const SwitchParam*>(ptr))
        {
            // a real-valued parameter (scaling factor or fitting parameter) may not 
            // (at this point) depend on a boolean.
            throw ParameterLink::InvalidInput
                    (" Attempt to link real valued parameter to a switch");
        } 
        else if (dynamic_cast<const ScaleParam*>(parent()))
        {
             // a scaling factor may not be made variable by being dependent on a 
             // fitting parameter (we already filtered out the case of SwitchParam
             // here).
             if (dynamic_cast<const ModParam*>(ptr)) throw ParameterLink::InvalidInput
                    (" Attempt to link constant scaling factor to variable fitting parameter");   
        }
        
        // if it got past all of that...
        
        m_members.push_back(ptr);
        added = true;
  }
  return added;
  //## end ParameterLink::addPointer%391AD167039F.body
}

Real ParameterLink::linkValue () const
{
  //## begin ParameterLink::linkValue%391C601001ED.body preserve=yes
   RealArray parVals(0.0,m_members.size());
   for (size_t i=0; i<m_members.size(); ++i)
   {
      parVals[i] = m_members[i]->value();
   }
  
   return m_linkString.evaluate(parVals);  
  //## end ParameterLink::linkValue%391C601001ED.body
}

void ParameterLink::putLink (std::ostream& s) const
{
  //## begin ParameterLink::putLink%39243D83006E.body preserve=yes
  string outputExpression(linkExpression(false));  
  s << "= " << outputExpression;
  //## end ParameterLink::putLink%39243D83006E.body
}

ParameterLink* ParameterLink::clone () const
{
  //## begin ParameterLink::clone%3A93F3940324.body preserve=yes
  //## end ParameterLink::clone%3A93F3940324.body

  return new ParameterLink(*this);
}

bool ParameterLink::findParam (const Parameter* param) const
{
  //## begin ParameterLink::findParam%3CA0905B01D4.body preserve=yes
  if (std::find(m_members.begin(),m_members.end(),param) 
                != m_members.end()) return true;
  return false;
  //## end ParameterLink::findParam%3CA0905B01D4.body
}

string ParameterLink::linkExpression (bool fullname) const
{
  //## begin ParameterLink::linkExpression%3FB92E6F035C.body preserve=yes
  
  string outputExpression;
  const string SPACE(" ");
  const size_t nT = m_linkString.tokenList().size();
  LinkExpression::ParamInfo::const_iterator itParID = 
        m_linkString.parIDs().begin();
  LinkExpression::ParamInfo::const_iterator itParIDEnd = 
        m_linkString.parIDs().end();
  size_t nextParLoc = (itParID == itParIDEnd) ? string::npos : itParID->second;
  size_t iPar = 0;
  for (size_t t = 0; t < nT; ++t)
  {
     const AbstractExpression::TokenType& curTok = m_linkString.tokenList()[t];
     if (t == nextParLoc)
     {
        const Parameter* par = m_members[iPar];
        const ResponseParam* resppar = dynamic_cast<const ResponseParam*>(par);
        if (fullname && !resppar)
        {
           const string parIdent(XSContainer::models->indexToName(par->index(),par->modelName()));
           // Data group number is appended to the end following a '$'.
           // Need to remove it and possibly add it to the front for display.
           string::size_type dgLoc = parIdent.find('$');
           string modifiedParID = parIdent.substr(0,dgLoc);
           modifiedParID = (modifiedParID.find(Model::DEFAULT()) == string::npos ?
                        modifiedParID : modifiedParID.substr(modifiedParID.find(':')+1));
           if ( XSContainer::datasets->numberOfGroups() > 1)
           {
              string dgNum(parIdent.substr(dgLoc+1));
              outputExpression += dgNum;
              outputExpression += string(":");
           }
           outputExpression += modifiedParID;
        }
        else
        {
           if (curTok.tokenString.find(Model::DEFAULT()) == string::npos)
              outputExpression += curTok.tokenString;
           else
           {
              string::size_type pos = curTok.tokenString.find(':') + 1;
              outputExpression += curTok.tokenString.substr(pos);
           }
        }
        ++itParID;
        nextParLoc = (itParID == itParIDEnd) ? string::npos : itParID->second;
        ++iPar;
     }
     else
     {
        bool isPm = false;
        if (curTok.type == AbstractExpression::Plus)
           isPm = true;
        else if (curTok.type == AbstractExpression::Minus)
        {
           isPm = true;
           // But check if this is part of an exponent.
           if (curTok.location > 0)
           {
              char prevChar = m_linkString.exprString()[curTok.location-1];
              if (prevChar == 'e' || prevChar == 'E')
                 isPm = false;
           }
        }
        if (isPm)  outputExpression += SPACE;
        outputExpression += curTok.tokenString;
        if (isPm)  outputExpression += SPACE;
     }  
  }
  
  return outputExpression;
  
  //## end ParameterLink::linkExpression%3FB92E6F035C.body
}

void ParameterLink::rerouteLink (const std::vector<Parameter*>& newPars)
{
  //## begin ParameterLink::rerouteLink%4460C85D0361.body preserve=yes
   if (newPars.size() != m_members.size())
      throw RedAlert("Parameter reroute mismatch.");
   for (size_t i=0; i<newPars.size(); ++i)
      m_members[i] = newPars[i];
   regenerateExpression();
  //## end ParameterLink::rerouteLink%4460C85D0361.body
}

void ParameterLink::regenerateExpression ()
{
  //## begin ParameterLink::regenerateExpression%4461F80F0327.body preserve=yes
  // This is for use in the context of an update after broken
  // links have been rerouted.
  // IMPORTANT: This ASSUMES that only the parameters may have changed,
  // and that the number of parameters remains constant.  
  string newExprStr;
  const size_t nT = m_linkString.tokenList().size();
  LinkExpression::ParamInfo::const_iterator itParID = 
        m_linkString.parIDs().begin();
  LinkExpression::ParamInfo::const_iterator itParIDEnd = 
        m_linkString.parIDs().end();
  size_t nextParLoc = (itParID == itParIDEnd) ? string::npos : itParID->second;
  size_t iPar = 0;
  for (size_t iTok=0; iTok<nT; ++iTok)
  {
     const AbstractExpression::TokenType& curTok = m_linkString.tokenList()[iTok];
     if (iTok == nextParLoc)
     {
        if (iPar >= m_members.size())
           throw RedAlert("Parameter retrieval error in ParameterLink::regenerateExpression");
        std::ostringstream oss;
        const Parameter* newPar = m_members[iPar];
        const ResponseParam* newRespPar = dynamic_cast<const ResponseParam*>(newPar);
        if (newRespPar)
           oss << newRespPar->responseParent()->sourceNumber() << ':';
        else if (newPar->modelName() != Model::DEFAULT())
           oss << newPar->modelName() << ':';
        oss << newPar->index();
        newExprStr += oss.str();
        ++itParID;
        nextParLoc = (itParID == itParIDEnd) ? string::npos : itParID->second;
        ++iPar;        
     }
     else
        newExprStr += curTok.tokenString;
  }
  
  LinkExpression newExpr;
  newExpr.init(newExprStr);  
  // The new LinkExpression object also has a new parIDs list.
  // This list naturally contains all the par strings that we
  // inserted into the expression above, but it may also contain
  // integer strings that don't correspond to any parameter (and
  // therefore need to be removed from parIDs).  They are easy to
  // spot though since they have token positions without counterparts
  // in the old parID list.
  std::vector<bool> isParFound(newExpr.parIDs().size(), false);
  itParID = m_linkString.parIDs().begin();
  LinkExpression::ParamInfo::const_iterator itNewParID =
        newExpr.parIDs().begin();
  LinkExpression::ParamInfo::const_iterator itNewParIDEnd =
        newExpr.parIDs().end();
  size_t iCount=0;
  size_t trueCount=0;
  while (itNewParID != itNewParIDEnd)
  {
     if (itParID != itParIDEnd && itNewParID->second == itParID->second)
     {
        isParFound[iCount] = true;
        ++trueCount;
        ++itParID;
     }
     ++itNewParID;
     ++iCount;
  }
  if (trueCount != m_linkString.parIDs().size())
     throw RedAlert("Parse error in ParameterLink::regenerateExpression");
  
  int savConVerbose = tpout.conVerbose();
  int savLogVerbose = tpout.logVerbose();
  try
  {
     // Temporarily raising verbose levels to prevent warning message
     // for param-to-integer-const conversion.  To display it from
     // here would be overkill.  
     XSstream::verbose(tpout, 99, 99);
     newExpr.resetParamInfo(isParFound);
     XSstream::verbose(tpout, savConVerbose, savLogVerbose);
  }
  catch (...)
  {
     XSstream::verbose(tpout, savConVerbose, savLogVerbose);
     throw;
  }
  m_linkString = newExpr;
  //## end ParameterLink::regenerateExpression%4461F80F0327.body
}

bool ParameterLink::wordToResponseParam (const string& word)
{
  //## begin ParameterLink::wordToResponseParam%49CD281C0390.body preserve=yes
  
  // For response parameters:
  //  [<sourceNum>:]<parNum>
  
  // We will ASSUME word contains no negative integers.  They should
  // already have been dealt with by this point.
  
    
  bool isAdded = false;
  int sourceNum = -1;
  int parNum = -1;
  if (XSparse::integerPair(word, sourceNum, parNum))
  {
     bool justOneInt = false;
     if (parNum == -1)
     {
        // If only one integer, apply it to parNum
        parNum = sourceNum;
        sourceNum = 1;
        justOneInt = true;
     }
     
     // We have sourceNum and parNum.  Does it point to an existing response
     // parameter?  In its current implementation, new Response parameters
     // are created only after any old ones they replace are removed from the
     // global map, which is in stark contrast to the Model parameters'
     // situation.  Therefore we don't need to worry about linking to 
     // something that is about to be removed.  And since there's nothing
     // analagous here to data group copies, anything we link to ought
     // to already be in the global map.
     
     const Parameter* respPar = 0;
     const XSContainer::RespParContainer& respPars = 
                XSContainer::responses->respParContainer();
     if (sourceNum && static_cast<size_t>(sourceNum) <= respPars.size())
     {
        if (parNum && static_cast<size_t>(parNum) <= respPars[sourceNum-1].size())
        {
           respPar = respPars[sourceNum-1][parNum-1];
        }
     }
     
     // As with mod params, we'll let slide the case of a missing par and just one
     // int specifier.  Assume they mean it as a numerical constant.
     if (respPar)
     {
        // Make sure it's not linking to itself (at least not directly).
        if (respPar == m_parent)
           throw InvalidInput(" Attempt to link parameter to itself");
        m_members.push_back(respPar);
        isAdded = true;   
     }
     else if (!justOneInt)
     {
        string err("No response parameter found for specifier ");
        err += word;
        throw InvalidInput(err);
     }
     
  }
  else
  {
     string err("Response parameter identifier must be of the form [<sourceNum>:]<parNum>");
     throw InvalidInput(err);
  }
  
  return isAdded;
  //## end ParameterLink::wordToResponseParam%49CD281C0390.body
}

// Additional Declarations
  //## begin ParameterLink%362F93D90212.declarations preserve=yes
  //## end ParameterLink%362F93D90212.declarations

//## begin module%3A928AC60278.epilog preserve=yes
//## end module%3A928AC60278.epilog
